/*
 * 3des.c
 *
 *  Created on: 2 dic. 2017
 *      Author: Carlos
 */

#include "FreeRTOS.h"
#include "task.h"

/* Standard includes. */
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "3des.h"
#include "des.h"

/*void tdes(unsigned char* block, unsigned char* block_process,
          unsigned char* key, int size_key, int mode, int tipo){
    uint8_t *clave;
    int tam_clave = 8;
    clave = (uint8_t*) pvPortMalloc(tam_clave * sizeof(uint8_t));
    key_set* key_sets = (key_set*) pvPortMalloc(17 * sizeof(key_set));
    int i = 0;
    for (i = 0; i < 3; i++)
    {
        if(mode==1){
        if((i==2)&&(size_key == 16))
        {
            memcpy(clave, &clave[0], tam_clave * sizeof(uint8_t));
        }
        else
        {
            memcpy(clave, &clave[i*tam_clave], tam_clave * sizeof(uint8_t));
        }
        }else{
            if((i==2)&&(size_key == 16))
                    {
                        memcpy(clave, &clave[0], tam_clave * sizeof(uint8_t));
                    }
                    else
                    {
                        memcpy(clave, &clave[(2-i)*tam_clave], tam_clave * sizeof(uint8_t));
                        //memcpy(clave, &clave[i*tam_clave], tam_clave * sizeof(uint8_t));
                    }
        }
        generate_sub_keys(clave, key_sets);
        if((i==1)&&(tipo == 1))
        {
            process_message(block, block_process, key_sets, !mode);
        }
        else
        {
            process_message(block, block_process, key_sets, mode);
        }
        memcpy(block, block_process, tam_clave * sizeof(uint8_t));
    }
    vPortFree(clave);
    vPortFree(key_sets);

}*/


void tdes(unsigned char* block, unsigned char* block_process,
          unsigned char* key, int size_key, int mode, int tipo){
    uint8_t *clave;
    int tam_clave = 8;
    clave = (uint8_t*) pvPortMalloc(tam_clave * sizeof(uint8_t));
    key_set* key_sets = (key_set*) pvPortMalloc(17 * sizeof(key_set));
    int i = 0;
    for (i = 0; i < 3; i++)
    {
        if(mode==1){

            memcpy(clave, &key[i*tam_clave], tam_clave * sizeof(uint8_t));

        }else{

            memcpy(clave, &key[(2-i)*tam_clave], tam_clave * sizeof(uint8_t));

        }
        generate_sub_keys(clave, key_sets);
        if(i==1){
            if(mode==1){
                process_message(block, block_process, key_sets, 0);
            }else{
                process_message(block, block_process, key_sets, 1);
            }
        }else{
            process_message(block, block_process, key_sets, mode);
        }

        memcpy(block, block_process, tam_clave * sizeof(uint8_t));
    }
    vPortFree(clave);
    vPortFree(key_sets);

}
