
import java.awt.EventQueue;
import java.awt.HeadlessException;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

//import gnu.io.SerialPort;

import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JButton;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JRadioButton;
import javax.swing.JTextArea;
import javax.swing.JScrollPane;
import javax.swing.JComboBox;
import javax.swing.ButtonGroup;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JFileChooser;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
//import java.io.FileNotFoundException;
import java.io.FileOutputStream;
//import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;

import java.util.Vector;

//import java.util.ArrayList;
//import java.util.Scanner;
import javax.swing.JCheckBox;
//import javax.swing.event.ChangeListener;
//import javax.swing.event.ChangeEvent;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;
/*import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;*/

public class Ventana extends JFrame implements Network_iface {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private JPanel contentPane;
	public JTextArea textLog;
	public static int speed = 19200;
	private static Network_jserial network;

	private JTextField textClave;
	private JTextField textSalida;
	private JCheckBox chckGuardar;
	private JTextField textVector;
	private JComboBox<String> comboModo;
	private JComboBox<String> comboAlgoritmo;
	private JRadioButton rdbtnEncriptar;
	private JTextArea textDatos;
	private JTextArea textRespuesta;
	private JTextArea textJava;
	private JRadioButton radioJavaBase;
	private JRadioButton rdbtnBase;
	private JRadioButton rdbtnBase_1;
	private JRadioButton rdbtnTexto;
	private JRadioButton rdbtnHexadecimal;
	private JRadioButton rdbtnHexadecimal_1;

	private JRadioButton radioJavaText;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JComboBox<String> comboPuerto;
	private final ButtonGroup GrupoClave = new ButtonGroup();
	private JRadioButton radioHexClave;
	private long publ_mod;
	private long publ_key;
	// private long priv_key;
	private final ButtonGroup buttonGroup_1 = new ButtonGroup();

	private int codificacion = 0;
	private int codificacionRespuesta = 0;
	private int codificacionJava = 0;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Ventana frame = new Ventana();
					frame.setVisible(true);
					network = new Network_jserial(0, frame, 255);
					frame.actualizaPuertos();

					/*
					 * if (network.connect("COM4", speed)) { System.out.println(); } else {
					 * System.out.println("sorry, there was an error connecting\n"); System.exit(1);
					 * }
					 */
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});

	}

	/**
	 * Create the frame.
	 */
	public Ventana() {
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 499, 836);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		setContentPane(contentPane);
		contentPane.setLayout(null);

		JLabel lblDatos = new JLabel("Datos");
		lblDatos.setBounds(30, 42, 46, 14);
		contentPane.add(lblDatos);

		JLabel lblVector = new JLabel("Vector");
		lblVector.setBounds(30, 322, 46, 14);
		lblVector.setVisible(false);
		contentPane.add(lblVector);

		comboModo = new JComboBox<String>();
		comboModo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				if (comboModo.getSelectedIndex() == 0) {
					textVector.setVisible(false);
					lblVector.setVisible(false);
				} else {
					textVector.setVisible(true);
					lblVector.setVisible(true);
				}
			}
		});
		comboModo.setModel(new DefaultComboBoxModel<String>(new String[] { "ECB", "CBC", "PCBC", "CFB", "OFB" }));
		comboModo.setBounds(80, 293, 372, 20);
		contentPane.add(comboModo);

		JButton btnBorrar = new JButton("Borrar");
		btnBorrar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				textLog.setText("");
				textRespuesta.setText("");
				textClave.setText("");
				textDatos.setText("");
				textVector.setText("");
				textJava.setText("");
				rdbtnEncriptar.setSelected(true);
				textSalida.setText("");
				chckGuardar.setSelected(false);
				comboModo.setSelectedIndex(0);
				comboAlgoritmo.setSelectedIndex(0);

			}
		});
		btnBorrar.setBounds(196, 763, 89, 23);
		contentPane.add(btnBorrar);

		JLabel lblLog = new JLabel("Log");
		lblLog.setBounds(30, 625, 70, 14);
		contentPane.add(lblLog);

		rdbtnEncriptar = new JRadioButton("Encriptar");
		rdbtnEncriptar.setSelected(true);
		rdbtnEncriptar.setBounds(80, 241, 109, 23);
		contentPane.add(rdbtnEncriptar);

		JRadioButton rdbtnDesencriptar = new JRadioButton("Desencriptar");
		rdbtnDesencriptar.setBounds(198, 241, 109, 23);
		contentPane.add(rdbtnDesencriptar);

		ButtonGroup grupo = new ButtonGroup();
		grupo.add(rdbtnEncriptar);
		grupo.add(rdbtnDesencriptar);

		JLabel lblAccin = new JLabel("Acci\u00F3n");
		lblAccin.setBounds(30, 246, 46, 14);
		contentPane.add(lblAccin);

		JFileChooser fileopen = new JFileChooser();
		FileFilter filter = new FileNameExtensionFilter("Texto", "txt");
		fileopen.addChoosableFileFilter(filter);

		JButton btnArchivo = new JButton("Archivo");
		btnArchivo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				int ret = fileopen.showDialog(null, "Open file");

				if (ret == JFileChooser.APPROVE_OPTION) {
					File file = fileopen.getSelectedFile();
					System.out.println(file);

					try {
						FileInputStream fis = new FileInputStream(fileopen.getSelectedFile().toString());
						InputStreamReader isr = new InputStreamReader(fis, "ISO-8859-1");
						BufferedReader br = new BufferedReader(isr);
						String[] partes;
						String linea = br.readLine();
						if (linea != null) {
							while (linea != null) {
								if (linea.contains("Algoritmo=")) {
									partes = linea.split("Algoritmo=");
									if (partes[1].equals("DES")) {
										comboAlgoritmo.setSelectedIndex(0);
									} else if (partes[1].equals("3DES")) {
										comboAlgoritmo.setSelectedIndex(1);
									} else if (partes[1].equals("AES (Software)")) {
										comboAlgoritmo.setSelectedIndex(2);
									} else if (partes[1].equals("AES (Hardware)")) {
										comboAlgoritmo.setSelectedIndex(3);
									} else if (partes[1].equals("RSA")) {
										comboAlgoritmo.setSelectedIndex(4);
									}

								} else if (linea.contains("Modo=")) {
									partes = linea.split("Modo=");
									if (partes[1].equals("ECB")) {
										comboModo.setSelectedIndex(0);
									} else if (partes[1].equals("CBC")) {
										comboModo.setSelectedIndex(1);
									} else if (partes[1].equals("PCBC")) {
										comboModo.setSelectedIndex(2);
									} else if (partes[1].equals("CFB")) {
										comboModo.setSelectedIndex(3);
									} else if (partes[1].equals("OFB")) {
										comboModo.setSelectedIndex(4);
									}

								} else if (linea.contains("Clave=")) {
									partes = linea.split("Clave=");
									radioHexClave.setSelected(true);
									textClave.setText(partes[1]);

								} else if (linea.contains("Encriptar=")) {
									partes = linea.split("Encriptar=");
									if (partes[1].equals("desencriptar")) {
										rdbtnEncriptar.setSelected(false);
										rdbtnDesencriptar.setSelected(true);
									} else {
										rdbtnEncriptar.setSelected(true);
										rdbtnDesencriptar.setSelected(false);
									}

								} else if (linea.contains("Mensaje=")) {
									partes = linea.split("Mensaje=");
									rdbtnHexadecimal.setSelected(true);
									textDatos.setText(partes[1]);
								} else if (linea.contains("Vector=")) {
									partes = linea.split("Vector=");
									if (partes.length > 1) {
										textVector.setText(partes[1]);
									}
								}

								linea = br.readLine();
							}
						} else {
							textLog.append("El fichero esta vacio");
						}

						br.close();
						isr.close();
						fis.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

				}

			}
		});
		btnArchivo.setBounds(271, 38, 89, 23);

		contentPane.add(btnArchivo);

		JButton btnSalir = new JButton("Salir");
		btnSalir.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}
		});
		btnSalir.setBounds(363, 763, 89, 23);
		contentPane.add(btnSalir);

		comboAlgoritmo = new JComboBox<String>();
		comboAlgoritmo.setModel(new DefaultComboBoxModel<String>(
				new String[] { "DES", "3DES", "AES (Software)", "AES (Hardware)", "RSA", "Login", "Logout" }));
		comboAlgoritmo.setBounds(80, 268, 372, 20);
		contentPane.add(comboAlgoritmo);

		JButton btnEnviar = new JButton("Enviar");
		btnEnviar.setEnabled(false);
		btnEnviar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (comboAlgoritmo.getSelectedIndex() == 4) {
					if (textDatos.getText().toString().equals("")) {
						JOptionPane.showMessageDialog(null, "El campo texto no puede estar vaco");
					} else {
						if (rdbtnEncriptar.isSelected()) {
							network.writeSerial("getPublicKey\n");
							boolean ok = network.read();
							String men_enc = "";
							String temp;
							if (ok) {
								textLog.append("key:" + publ_key);
								String datos = "";

								try {
									if (rdbtnHexadecimal.isSelected()) {
										datos = Utilidades.toStr(textDatos.getText());
									} else {
										datos = new String(textDatos.getText().getBytes("ISO-8859-1"));
									}

								} catch (UnsupportedEncodingException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}

								long[] encriptado = Rsa2.rsa_encrypt(datos, // textDatos.getText(),
										(long) datos.length(), publ_key, publ_mod);
								String mod = Long.toString(publ_mod);

								int mod_len = mod.length();

								for (int i = 0; i < encriptado.length; i++) {

									temp = Long.toString(encriptado[i]);
									while (temp.length() < mod_len) {
										temp = "0" + temp;
									}

									men_enc = men_enc + temp;
								}
								textLog.append("\n" + men_enc);
								textJava.setText(men_enc);
								int tam = men_enc.length();
								network.writeSerial("IniRSA " + tam + " 0\n");
								ok = network.read();

								if (ok) {
									int tam_bloque = 150;
									int numbloques = tam / tam_bloque + ((tam % tam_bloque > 0) ? 1 : 0);
									int i = 0;
									String bloque = "";
									while ((ok) && (i < numbloques)) {
										// if ((i + 1) * tam_bloque < textDatos.getText().toString().length()) {
										if ((i + 1) * tam_bloque < men_enc.length()) {
											// bloque = textDatos.getText().substring(i * tam_bloque, (i + 1) *
											// tam_bloque);
											bloque = men_enc.substring(i * tam_bloque, (i + 1) * tam_bloque);
										} else {
											// bloque = textDatos.getText().substring(i * tam_bloque,
											// textDatos.getText().length());
											// bloque = procesada.substring(i * tam_bloque,
											// textDatos.getText().length());
											bloque = men_enc.substring(i * tam_bloque, men_enc.length());
										}
										// network.writeSerial("text_data \"" + bloque + "\"\n");

										temp = "rsa_data " + bloque + "\n";
										System.out.println(temp);

										try {
											Thread.sleep(100);
										} catch (InterruptedException e1) {
											// TODO Auto-generated catch block
											e1.printStackTrace();
										}
										network.writeSerial(temp);
										ok = network.read();
										// network.writeSerial("Datos\n");
										// ok = network.read();
										i++;
									}
								}
								try {
									Thread.sleep(100);
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
								temp = "MD5 " + Utilidades.getMD5(men_enc) + "\n";
								network.writeSerial(temp);
								ok = network.read();
								try {
									Thread.sleep(100);
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
								if (!ok) {
									JOptionPane.showMessageDialog(null, "El checksum no coincide.");

								} else {

									network.writeSerial("RSA 0\n");
									ok = network.read();
									if (ok) {
										// network.writeSerial("Datos 1\n");
										network.writeSerial("datos_hex\n");
										ok = network.read();
									}
									/*
									 * network.writeSerial("Datos\n"); ok = network.read();
									 */
								}
							}
						} else {
							Rsa2 rsa = new Rsa2();
							rsa.rsa_gen_keys();
							network.writeSerial("setPublicKey " + rsa.pubkey + " " + rsa.pubmodulus + "\n");
							System.out.println("setPublicKey " + rsa.pubkey + " " + rsa.pubmodulus + "\n");
							boolean ok = network.read();
							if (!ok) {
								JOptionPane.showMessageDialog(null, "Error al recibir la privada");
							} else {
								String datos = "";
								String temp = "";
								int tam = 0;
								try {// CAMBIAR!!!
									
									
									
									
									if (rdbtnTexto.isSelected()) {
										datos = Utilidades.toHex(textDatos.getText());
										tam = textDatos.getText().getBytes("ISO-8859-1").length;
									} else if (rdbtnHexadecimal.isSelected()) {
										datos = textDatos.getText();
										tam = textDatos.getText().getBytes("ISO-8859-1").length / 2;
									} else if (rdbtnBase.isSelected()) {
										datos = Utilidades.BasetoString(textDatos.getText());
										tam = datos.getBytes("ISO-8859-1").length;
										datos = Utilidades.toHex(datos);
										}

								} catch (UnsupportedEncodingException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}

								network.writeSerial("IniRSA " + tam + " 1\n");
								ok = network.read();
								tam = datos.length();
								if (ok) {

									int tam_bloque = 150;
									int numbloques = tam / tam_bloque + ((tam % tam_bloque > 0) ? 1 : 0);
									int i = 0;
									String bloque = "";
									System.out.println("num_bloques" + numbloques);
									while ((ok) && (i < numbloques)) {

										if ((i + 1) * tam_bloque < datos.length()) {
											bloque = datos.substring(i * tam_bloque, (i + 1) * tam_bloque);
										} else {
											bloque = datos.substring(i * tam_bloque, datos.length());
										}

										temp = "text_data " + bloque + "\n";
										System.out.println(temp);

										try {
											Thread.sleep(100);
										} catch (InterruptedException e1) {
											// TODO Auto-generated catch block
											e1.printStackTrace();
										}
										network.writeSerial(temp);
										ok = network.read();

										// network.writeSerial("Datos\n");
										// ok = network.read();
										i++;
									}

									String Str2 = "";
									try {
										if (rdbtnHexadecimal.isSelected()) {
											Str2 = Utilidades.toStr(textDatos.getText());
											temp = "MD5 " + Utilidades.getMD5(Str2) + "\n";
										} else if (rdbtnBase.isSelected()) {
											Str2 = Utilidades.BasetoString(textDatos.getText());
											temp = "MD5 " + Utilidades.getMD5(Str2) + "\n";
										} else {
											Str2 = new String(textDatos.getText().getBytes("ISO-8859-1"));
											// Str2 = new String (textDatos.getText().getBytes( ));
											Str2 = textDatos.getText();
											temp = "MD5 " + Utilidades.getMD5(Str2) + "\n";
										}
									} catch (HeadlessException | UnsupportedEncodingException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									}
									System.out.print(temp);
									try {
										Thread.sleep(100);
									} catch (InterruptedException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									}
									network.writeSerial(temp);
									ok = network.read();
									try {
										Thread.sleep(100);
									} catch (InterruptedException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									}
									if (!ok) {
										JOptionPane.showMessageDialog(null, "El checksum no coincide.");

									} else {

										if (ok) {
											network.writeSerial("RSA 1\n");
											ok = network.read();

											if (ok) {
												network.writeSerial("Datos 1\n");
												ok = network.read();
												if (ok) {
													String mensaje = textRespuesta.getText();
													String mod = Long.toString(rsa.primodulus);
													int mod_len = mod.length();

													long[] mensaje_encriptado = new long[mensaje.length() / mod_len];
													for (i = 0; i < mensaje.length() / mod_len; i++) {
														String aux = mensaje.substring(i * mod_len, (i + 1) * mod_len);
														System.out.println(aux);
														mensaje_encriptado[i] = Long.parseLong(aux);

													}

													textJava.setText(rsa.rsa_decrypt(mensaje_encriptado,
															mensaje_encriptado.length, rsa.prikey, rsa.primodulus));
												}
											}
										}

									}

								}
							}

						}
					}
				} else if (comboAlgoritmo.getSelectedIndex() == 5) {
					if (textDatos.getText().toString().equals("")) {
						JOptionPane.showMessageDialog(null, "El campo texto no puede estar vaco");
					} else if (textDatos.getText().length() > 100) {
						JOptionPane.showMessageDialog(null, "Password demasiado largo");
					} else {

						network.writeSerial("getPublicKey\n");
						boolean ok = network.read();
						String men_enc = "";
						String temp;
						if (ok) {
							textLog.append("key:" + publ_key);
							String datos = "";
							try {
								datos = new String(textDatos.getText().getBytes("ISO-8859-1"));
							} catch (UnsupportedEncodingException e2) {
								// TODO Auto-generated catch block
								e2.printStackTrace();
							}
							long[] encriptado = Rsa2.rsa_encrypt(datos, // textDatos.getText(),
									(long) textDatos.getText().length(), publ_key, publ_mod);
							String mod = Long.toString(publ_mod);

							int mod_len = mod.length();

							for (int i = 0; i < encriptado.length; i++) {

								temp = Long.toString(encriptado[i]);
								while (temp.length() < mod_len) {
									temp = "0" + temp;
								}
								textLog.append("\n" + temp);
								men_enc = men_enc + temp;
							}
							textLog.append("\n" + men_enc);
							textJava.setText(men_enc);
							// int tam = men_enc.length();
							try {
								Thread.sleep(100);
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							network.writeSerial("LOGIN " + men_enc + "\n");
							try {
								Thread.sleep(100);
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
							ok = network.read();
							if (ok) {
								JOptionPane.showMessageDialog(null, "Login Correcto");

							} else {
								JOptionPane.showMessageDialog(null, "Login Incorrecto");

							}
							/*
							 * network.writeSerial("Datos\n"); ok = network.read();
							 */

						}

					}
				} else if (comboAlgoritmo.getSelectedIndex() == 6) {
					network.writeSerial("LOGOUT\n");
					boolean ok = network.read();
					if (ok) {
						JOptionPane.showMessageDialog(null, "Sesion Cerrada");

					} else {
						JOptionPane.showMessageDialog(null, "La sesion no ha podido ser cerrada");

					}

				} else if (comboAlgoritmo.getSelectedIndex() < 4) {
					String Clave = "";
					if (!radioHexClave.isSelected()) {
						Clave = Utilidades.toHex(textClave.getText());
					} else {
						Clave = textClave.getText();
					}
					
					if (((Clave.length() != 32) && (Clave.length() != 48) && (Clave.length() != 64))
							&& ((comboAlgoritmo.getSelectedIndex() == 2) || (comboAlgoritmo.getSelectedIndex() == 3))) {
						if(Clave.length() < 32) {
							while(Clave.length() < 32) {
								Clave=Clave+"00";
							}
							
						}else if ((Clave.length() < 48)&&(Clave.length() > 32)) {
							while(Clave.length() < 48) {
								Clave=Clave+"00";
							}
						}else if ((Clave.length() < 64)&&(Clave.length() > 48)){
							while(Clave.length() < 64) {
								Clave=Clave+"00";
							}
						}
					}
					System.out.println("CLAVE: "+Clave);
///REVISARRR!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
					if (textClave.getText().toString().equals("")) {
						JOptionPane.showMessageDialog(null, "El campo clave no puede estar vaco");

					} else if ((Clave.length() != 16) && (comboAlgoritmo.getSelectedIndex() == 0)) {
						JOptionPane.showMessageDialog(null, "La longitud del campo clave debe ser 8 caracteres");
					} else if ((Clave.length() != 48) && (comboAlgoritmo.getSelectedIndex() == 1)) {
						JOptionPane.showMessageDialog(null, "La longitud del campo clave debe ser 24 caracteres");
					} else if (((Clave.length() != 32) && (Clave.length() != 48) && (Clave.length() != 64))
							&& ((comboAlgoritmo.getSelectedIndex() == 2) || (comboAlgoritmo.getSelectedIndex() == 3))) {
						JOptionPane.showMessageDialog(null,
								"La longitud del campo clave debe ser 16, 24 o 32 caracteres");
					} else if ((comboModo.getSelectedIndex() != 0)
							&& ((comboAlgoritmo.getSelectedIndex() == 0) || (comboAlgoritmo.getSelectedIndex() == 1))
							&& (textVector.getText().toString().length() != 8)) {
						JOptionPane.showMessageDialog(null, "La longitud del campo vector debe ser 8 caracteres");
					} else if ((comboModo.getSelectedIndex() != 0)
							&& ((comboAlgoritmo.getSelectedIndex() == 2) || (comboAlgoritmo.getSelectedIndex() == 3))
							&& (textVector.getText().toString().trim().length() != 16)) {
						JOptionPane.showMessageDialog(null, "La longitud del campo vector debe ser 16 caracteres");

					} else {
						String regex = "^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$";

						if (textDatos.getText().toString().equals("")) {
							JOptionPane.showMessageDialog(null, "El campo datos no puede estar vaco");
						} else if ((rdbtnHexadecimal.isSelected()) && (!textDatos.getText().matches("[0-9A-Fa-f]+"))) {
							JOptionPane.showMessageDialog(null, "Hay caracteres no Hexadecimales");
						//} else if ((rdbtnBase.isSelected()) && (!textDatos.getText().matches(regex))) {
						//	JOptionPane.showMessageDialog(null, "El mensaje no esta en Base64 ");
						} else {
							String procesada = "";
							int tam2 = 0;
							int encriptar = 0;
							if (rdbtnEncriptar.isSelected()) {
								encriptar = 1;
							}
							byte[] isoBytes = null;
							try {
								if (rdbtnTexto.isSelected()) {
									procesada = Utilidades.toHex(textDatos.getText());
									tam2 = textDatos.getText().getBytes("ISO-8859-1").length;
								} else if (rdbtnHexadecimal.isSelected()) {
									procesada = textDatos.getText();
									tam2 = textDatos.getText().getBytes("ISO-8859-1").length / 2;
								} else if (rdbtnBase.isSelected()) {
									procesada = Utilidades.BasetoString(textDatos.getText());
									tam2 = procesada.getBytes("ISO-8859-1").length;
									procesada = Utilidades.toHex(procesada);

								}

								isoBytes = procesada.getBytes("ISO-8859-1");

							} catch (UnsupportedEncodingException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}

							int tam = isoBytes.length;
							int tam_bloque = 150;
							int numbloques = tam / tam_bloque + ((tam % tam_bloque > 0) ? 1 : 0);

							JOptionPane.showMessageDialog(null, "tamao: " + tam + " num bloques: " + numbloques);

							String temp = "ini " + comboAlgoritmo.getSelectedIndex() + " " + tam2 + " "
									+ comboModo.getSelectedItem().toString() + " " + Clave + " "
									+ Utilidades.toHex(textVector.getText()) + "\n";
							System.out.println(temp);
							network.writeSerial(temp);

							boolean ok = network.read();

							/*
							 * network.writeSerial("Datos\n"); ok = network.read();
							 */

							int i = 0;
							String bloque = "";

							if (ok) {
								try {
									Thread.sleep(100);
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
								while ((ok) && (i < numbloques)) {
									if ((i + 1) * tam_bloque < procesada.length()) {
										bloque = procesada.substring(i * tam_bloque, (i + 1) * tam_bloque);
									} else {
										bloque = procesada.substring(i * tam_bloque, procesada.length());
									}

									temp = "text_data " + bloque + "\n";

									// temp = "b " + bloque + "\n";

									System.out.println(temp);
									network.writeSerial(temp);
									ok = network.read();
									try {
										Thread.sleep(100);
									} catch (InterruptedException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									}
									// network.writeSerial("Datos\n");
									// ok = network.read();
									i++;

								}
								if (!ok) {
									JOptionPane.showMessageDialog(null, "HA OCURRIDO UN ERROR");
								} else {

									String Str2 = "";
									try {
										if (rdbtnHexadecimal.isSelected()) {
											Str2 = Utilidades.toStr(textDatos.getText());
											temp = "MD5 " + Utilidades.getMD5(Str2) + "\n";
										} else if (rdbtnBase.isSelected()) {
											Str2 = Utilidades.BasetoString(textDatos.getText());
											temp = "MD5 " + Utilidades.getMD5(Str2) + "\n";
										}

										else {
											Str2 = new String(textDatos.getText().getBytes("ISO-8859-1"));
											// Str2 = new String (textDatos.getText().getBytes( ));
											Str2 = textDatos.getText();
											temp = "MD5 " + Utilidades.getMD5(Str2) + "\n";
										}
									} catch (HeadlessException | UnsupportedEncodingException e1) {
										// TODO Auto-generated catch block
										e1.printStackTrace();
									}
									System.out.println(temp);
									network.writeSerial(temp);

									ok = network.read();

									if (!ok) {
										JOptionPane.showMessageDialog(null, "Los checksum no coinciden");
									}

									network.writeSerial("datos_hex\n");
									ok = network.read();

									// JOptionPane.showMessageDialog(null, u.getMD5(procesada));
									// network.writeSerial("MD5 \"" + u.getMD5(procesada) + "\"\n");

									/*
									 * network.writeSerial("Datos\n"); ok=network.read();
									 */

									if (ok) {

										// network.writeSerial("Datos\n");
										// ok = network.read();

										// network.writeSerial("DES " + encriptar + "\n");
										// ok = network.read();
										String alg = "";
										if (comboAlgoritmo.getSelectedIndex() == 3) {
											alg = "AES";
											network.writeSerial("AES_H " + encriptar + "\n");
											ok = network.read();

										} else if (comboAlgoritmo.getSelectedIndex() == 0) {
											alg = "DES";
											network.writeSerial("DES " + encriptar + "\n");
											ok = network.read();

										} else if (comboAlgoritmo.getSelectedIndex() == 2) {
											alg = "AES";
											network.writeSerial("AES " + encriptar + "\n");
											ok = network.read();

										} else if (comboAlgoritmo.getSelectedIndex() == 1) {
											alg = "DESede";
											network.writeSerial("TDES " + encriptar + "\n");
											ok = network.read();

										}

										network.writeSerial("datos_hex\n");
										ok = network.read();

										// JAVA

										if (ok) {
											if (alg.equals("AES")) {

												while (procesada.length() % 32 != 0) {
													procesada = procesada + "00";
												}

											} else {
												while (procesada.length() % 16 != 0) {
													procesada = procesada + "00";
												}
											}
											if (rdbtnEncriptar.isSelected()) {
												String modo = comboModo.getSelectedItem().toString();
												String vector = textVector.getText();
												byte[] mensByte = Encriptador.encriptar(alg, modo,
														Utilidades.toStr(Clave), vector, Utilidades.toStr(procesada));
												char[] prueba = new char[mensByte.length];
												for (i = 0; i < mensByte.length; i++) {

													if (mensByte[i] < 0) {
														prueba[i] = (char) (mensByte[i] + 256);

													} else {
														prueba[i] = (char) mensByte[i];
													}

												}

												String mens = new String(prueba);
												/*
												 * try { mens = new String(mensByte.getBytes("ISO-8859-1")); } catch
												 * (UnsupportedEncodingException e1) { // TODO Auto-generated catch
												 * block e1.printStackTrace(); }
												 */
												if (radioJavaText.isSelected()) {
													textJava.setText(mens);
												} else if (radioJavaBase.isSelected()) {
													textJava.setText(Utilidades.toBase(mens));
												} else {
													textJava.setText(Utilidades.toHex(mens));
												}

											} else {
												String modo = comboModo.getSelectedItem().toString();
												String vector = textVector.getText();
												byte[] mensByte = Encriptador.desencriptar(alg, modo,
														Utilidades.toStr(Clave), vector, Utilidades.toStr(procesada));
												char[] prueba = new char[mensByte.length];
												for (i = 0; i < mensByte.length; i++) {

													if (mensByte[i] < 0) {
														prueba[i] = (char) (mensByte[i] + 256);

													} else {
														prueba[i] = (char) mensByte[i];
													}

												}

												String mens = new String(prueba);
												if (radioJavaText.isSelected()) {
													textJava.setText(mens);
												} else if (radioJavaBase.isSelected()) {
													textJava.setText(Utilidades.toBase(mens));
												}  else {
													textJava.setText(Utilidades.toHex(mens));
												}
											}
										}

									}
								}

							} else {
								JOptionPane.showMessageDialog(null, "Error");
							}
							;

						}
					}

				}

			}
		});
		btnEnviar.setBounds(30, 763, 89, 23);
		contentPane.add(btnEnviar);

		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(30, 641, 422, 111);
		contentPane.add(scrollPane);

		textLog = new JTextArea();
		scrollPane.setViewportView(textLog);

		JLabel label = new JLabel("Clave");
		label.setBounds(30, 187, 46, 14);
		contentPane.add(label);

		textClave = new JTextField();
		textClave.setColumns(10);
		textClave.setBounds(80, 184, 372, 20);
		contentPane.add(textClave);

		JButton button = new JButton("Generar Clave");
		button.setEnabled(false);
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				int tamano = 0;
				if (comboAlgoritmo.getSelectedIndex() == 0) {
					tamano = 8;
				} else if (comboAlgoritmo.getSelectedIndex() == 1) {
					tamano = 24;
				} else {
					tamano = 32;
				}
				radioHexClave.setSelected(true);
				network.writeSerial("keygen " + tamano + "\n");
				network.read();
			}
		});
		button.setBounds(333, 209, 118, 23);
		contentPane.add(button);

		JLabel lblAlgoritmo = new JLabel("Algoritmo");
		lblAlgoritmo.setBounds(30, 271, 46, 14);
		contentPane.add(lblAlgoritmo);

		JLabel lblModo = new JLabel("Modo");
		lblModo.setBounds(30, 296, 46, 14);
		contentPane.add(lblModo);

		JButton btnSalida = new JButton("Archivo");
		btnSalida.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				int ret = fileopen.showDialog(null, "Open file");
				if (ret == JFileChooser.APPROVE_OPTION) {
					File file = fileopen.getSelectedFile();
					// System.out.println(file);
					textSalida.setText(file.toString());
				}
			}
		});
		btnSalida.setBounds(363, 342, 89, 23);
		btnSalida.setVisible(false);
		contentPane.add(btnSalida);

		textSalida = new JTextField();
		textSalida.setBounds(145, 343, 210, 20);

		contentPane.add(textSalida);
		textSalida.setColumns(10);
		textSalida.setVisible(false);

		chckGuardar = new JCheckBox("Guardar Salida");
		chckGuardar.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (chckGuardar.isSelected()) {
					btnSalida.setVisible(true);
					textSalida.setVisible(true);
				} else {
					btnSalida.setVisible(false);
					textSalida.setVisible(false);
				}
			}
		});
		chckGuardar.setBounds(30, 340, 109, 23);
		contentPane.add(chckGuardar);

		textVector = new JTextField();
		textVector.setBounds(80, 319, 372, 20);
		textVector.setVisible(false);
		contentPane.add(textVector);
		textVector.setColumns(10);

		JScrollPane scrollPane_1 = new JScrollPane();
		scrollPane_1.setBounds(30, 65, 422, 87);
		contentPane.add(scrollPane_1);

		textDatos = new JTextArea();
		scrollPane_1.setViewportView(textDatos);

		JButton btnExportar = new JButton("Exportar");
		btnExportar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				int ret = fileopen.showDialog(null, "Open file");

				if (ret == JFileChooser.APPROVE_OPTION) {
					File file = fileopen.getSelectedFile();
					System.out.println(file);

					try {
						String encriptar = "";
						OutputStream fout = new FileOutputStream(fileopen.getSelectedFile().toString());
						OutputStreamWriter fichero = new OutputStreamWriter(fout, "ISO-8859-1");
						fichero.write("Algoritmo=" + comboAlgoritmo.getSelectedItem().toString() + "\r\n");
						fichero.write("Modo=" + comboModo.getSelectedItem().toString() + "\r\n");

						if (radioHexClave.isSelected()) {
							fichero.write("Clave=" + textClave.getText().toString() + "\r\n");
						} else {
							fichero.write("Clave=" + Utilidades.toHex(textClave.getText().toString()) + "\r\n");
						}
						if (rdbtnEncriptar.isSelected()) {
							encriptar = "encriptar";
						} else {
							encriptar = "desencriptar";
						}
						fichero.write("Encriptar=" + encriptar + "\r\n");
						fichero.write("Vector=" + textVector.getText() + "\r\n");
						if (rdbtnHexadecimal.isSelected()) {
							fichero.write("Mensaje=" + textDatos.getText() + "\r\n");
						} else {
							fichero.write("Mensaje=" + Utilidades.toHex(textDatos.getText()) + "\r\n");
						}
						fichero.close();
						fout.close();
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

				}
			}
		});
		btnExportar.setBounds(363, 38, 89, 23);
		contentPane.add(btnExportar);

		rdbtnHexadecimal = new JRadioButton("Hexadecimal");
		rdbtnHexadecimal.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (rdbtnHexadecimal.isSelected()) {
					if (codificacion == 0) {
						if (!textDatos.getText().equals("")) {
							textDatos.setText(Utilidades.toHex(textDatos.getText()));
						}
						codificacion = 1;
					} else if (codificacion == 2) {
						if (textDatos.getText().equals("")) {
							codificacion = 1;
						} else {
							String regex = "^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$";
							if (textDatos.getText().matches(regex)) {
								String aux = Utilidades.BasetoString(textDatos.getText());
								textDatos.setText(Utilidades.toHex(aux));
								codificacion = 1;
							} else {
								JOptionPane.showMessageDialog(null, "El mensaje no esta en Base64");
								rdbtnBase.setSelected(true);
							}
						}
					}
				}
			}
		});
		rdbtnHexadecimal.setBounds(198, 159, 109, 23);
		contentPane.add(rdbtnHexadecimal);

		rdbtnTexto = new JRadioButton("Texto");
		rdbtnTexto.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (rdbtnTexto.isSelected()) {
					if (codificacion == 1) {

						if (textDatos.getText().equals("")) {
							codificacion = 0;
						} else if (textDatos.getText().matches("[0-9A-Fa-f]+")) {
							textDatos.setText(Utilidades.toStr(textDatos.getText()));
							codificacion = 0;
						} else {
							JOptionPane.showMessageDialog(null, "El mensaje contiene caracteres no Hexadecimales");
							rdbtnHexadecimal.setSelected(true);

						}
					} else if (codificacion == 2) {
						if (textDatos.getText().equals("")) {
							codificacion = 0;
						} else {
							
								textDatos.setText(Utilidades.BasetoString(textDatos.getText()));
								codificacion = 0;
							
						}
					}
				}
			}
		});
		rdbtnTexto.setSelected(true);
		rdbtnTexto.setBounds(80, 159, 109, 23);
		contentPane.add(rdbtnTexto);

		ButtonGroup grupo_text_Hex = new ButtonGroup();
		grupo_text_Hex.add(rdbtnTexto);
		grupo_text_Hex.add(rdbtnHexadecimal);

		JLabel lblRespuesta = new JLabel("Respuesta");
		lblRespuesta.setBounds(30, 370, 89, 14);
		contentPane.add(lblRespuesta);

		JScrollPane scrollPane_2 = new JScrollPane();
		scrollPane_2.setBounds(30, 387, 422, 78);
		contentPane.add(scrollPane_2);

		textRespuesta = new JTextArea();
		scrollPane_2.setViewportView(textRespuesta);

		rdbtnHexadecimal_1 = new JRadioButton("Hexadecimal");
		rdbtnHexadecimal_1.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (rdbtnHexadecimal_1.isSelected()) {
					if (codificacionRespuesta == 0) {
						if (!textRespuesta.getText().equals("")) {
							textRespuesta.setText(Utilidades.toHex(textRespuesta.getText()));
						}
						codificacionRespuesta = 1;
					} else if (codificacionRespuesta == 2) {
						if (textRespuesta.getText().equals("")) {
							codificacionRespuesta = 1;
						} else {
							String regex = "^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$";
							if (textRespuesta.getText().matches(regex)) {
								String aux = Utilidades.BasetoString(textRespuesta.getText());
								textRespuesta.setText(Utilidades.toHex(aux));
								codificacionRespuesta = 1;
							} else {
								JOptionPane.showMessageDialog(null, "El mensaje no esta en Base64");
								rdbtnBase_1.setSelected(true);
							}
						}
					}
				}
			}
		});
		buttonGroup.add(rdbtnHexadecimal_1);
		rdbtnHexadecimal_1.setBounds(191, 472, 109, 23);
		contentPane.add(rdbtnHexadecimal_1);

		JRadioButton rdbtnTexto_1 = new JRadioButton("Texto");
		rdbtnTexto_1.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if (rdbtnTexto_1.isSelected()) {
					if (codificacionRespuesta == 1) {

						if (textRespuesta.getText().equals("")) {
							codificacionRespuesta = 0;
						} else if (textRespuesta.getText().matches("[0-9A-Fa-f]+")) {
							textRespuesta.setText(Utilidades.toStr(textRespuesta.getText()));
							codificacionRespuesta = 0;
						} else {
							JOptionPane.showMessageDialog(null, "El mensaje contiene caracteres no Hexadecimales");
							rdbtnHexadecimal_1.setSelected(true);

						}
					} else if (codificacionRespuesta == 2) {
						if (textRespuesta.getText().equals("")) {
							codificacionRespuesta = 0;
						} else {
							String regex = "^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$";
							if (textRespuesta.getText().matches(regex)) {
								textRespuesta.setText(Utilidades.BasetoString(textRespuesta.getText()));
								codificacionRespuesta = 0;
							} else {
								JOptionPane.showMessageDialog(null, "El mensaje no esta en Base64");
								rdbtnBase_1.setSelected(true);
							}
						}
					}
				}
			}
		});
		rdbtnTexto_1.setSelected(true);
		buttonGroup.add(rdbtnTexto_1);
		rdbtnTexto_1.setBounds(80, 472, 109, 23);
		contentPane.add(rdbtnTexto_1);

		comboPuerto = new JComboBox<String>();
		comboPuerto.setBounds(30, 11, 233, 20);

		contentPane.add(comboPuerto);

		JButton btnDesconectar = new JButton("Desconectar");
		btnDesconectar.setEnabled(false);
		JButton btnConectar = new JButton("Conectar");
		btnConectar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				try {
					if (network.connect(comboPuerto.getItemAt(comboPuerto.getSelectedIndex()).toString(), speed)) {
						button.setEnabled(true);
						btnDesconectar.setEnabled(true);
						btnConectar.setEnabled(false);
						btnEnviar.setEnabled(true);
						System.out.println();
					} else {
						System.out.println("Ha habido un error en la conexin\n");
						JOptionPane.showMessageDialog(null, "No se ha podido conectar con el puerto"
								+ comboPuerto.getItemAt(comboPuerto.getSelectedIndex()).toString());

					}
				} catch (Exception e) {
					e.printStackTrace();
				}

			}
		});
		btnConectar.setBounds(271, 10, 89, 23);
		contentPane.add(btnConectar);

		btnDesconectar.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (network.disconnect()) {
					button.setEnabled(false);
					btnDesconectar.setEnabled(false);
					btnConectar.setEnabled(true);
					btnEnviar.setEnabled(false);
				} else {
					JOptionPane.showMessageDialog(null, "No se ha podido desconectar con el puerto"
							+ comboPuerto.getItemAt(comboPuerto.getSelectedIndex()).toString());
				}

			}
		});
		btnDesconectar.setBounds(363, 10, 89, 23);
		contentPane.add(btnDesconectar);

		radioHexClave = new JRadioButton("Hexadecimal");
		GrupoClave.add(radioHexClave);
		radioHexClave.setBounds(198, 208, 109, 23);
		contentPane.add(radioHexClave);

		JRadioButton radioTextClave = new JRadioButton("Texto");
		radioTextClave.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {
				if (radioTextClave.isSelected()) {
					if (textClave.getText().equals("")) {

					} else if (textClave.getText().matches("[0-9A-Fa-f]+")) {
						textClave.setText(Utilidades.toStr(textClave.getText()));
					} else {
						JOptionPane.showMessageDialog(null, "El mensaje contiene caracteres no Hexadecimales");
						radioHexClave.setSelected(true);
					}
				} else {
					if (!textClave.getText().equals("")) {
						textClave.setText(Utilidades.toHex(textClave.getText()));
					}
				}
			}
		});
		GrupoClave.add(radioTextClave);
		radioTextClave.setSelected(true);
		radioTextClave.setBounds(80, 208, 109, 23);
		contentPane.add(radioTextClave);

		JLabel lblJava = new JLabel("Java");
		lblJava.setBounds(30, 498, 89, 14);
		contentPane.add(lblJava);

		JScrollPane scrollPane_3 = new JScrollPane();
		scrollPane_3.setBounds(30, 515, 422, 78);
		contentPane.add(scrollPane_3);

		textJava = new JTextArea();
		scrollPane_3.setViewportView(textJava);

		JRadioButton radioJavaHex = new JRadioButton("Hexadecimal");
		radioJavaHex.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (radioJavaHex.isSelected()) {
					if (codificacionJava == 0) {
						if (!textJava.getText().equals("")) {
							textJava.setText(Utilidades.toHex(textJava.getText()));
						}
						codificacionJava = 1;
					} else if (codificacionJava == 2) {
						if (textJava.getText().equals("")) {
							codificacionJava = 1;
						} else {
							String regex = "^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$";
							if (textJava.getText().matches(regex)) {
								String aux = Utilidades.BasetoString(textJava.getText());
								textJava.setText(Utilidades.toHex(aux));
								codificacionJava = 1;
							} else {
								JOptionPane.showMessageDialog(null, "El mensaje no esta en Base64");
								radioJavaBase.setSelected(true);
							}
						}
					}
				}
			}
		});
		buttonGroup_1.add(radioJavaHex);
		radioJavaHex.setBounds(191, 600, 109, 23);
		contentPane.add(radioJavaHex);

		radioJavaText = new JRadioButton("Texto");

		radioJavaText.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent arg0) {

				if (radioJavaText.isSelected()) {
					if (codificacionJava == 1) {

						if (textJava.getText().equals("")) {
							codificacionJava = 0;
						} else if (textJava.getText().matches("[0-9A-Fa-f]+")) {
							textJava.setText(Utilidades.toStr(textJava.getText()));
							codificacionJava = 0;
						} else {
							JOptionPane.showMessageDialog(null, "El mensaje contiene caracteres no Hexadecimales");
							radioJavaHex.setSelected(true);

						}
					} else if (codificacionJava == 2) {
						if (textJava.getText().equals("")) {
							codificacionJava = 0;
						} else {
							String regex = "^([A-Za-z0-9+/]{4})*([A-Za-z0-9+/]{4}|[A-Za-z0-9+/]{3}=|[A-Za-z0-9+/]{2}==)$";
							if (textJava.getText().matches(regex)) {
								textJava.setText(Utilidades.BasetoString(textJava.getText()));
								codificacionJava = 0;
							} else {
								JOptionPane.showMessageDialog(null, "El mensaje no esta en Base64");
								radioJavaBase.setSelected(true);
							}
						}
					}
				}
			}
		});
		buttonGroup_1.add(radioJavaText);
		radioJavaText.setSelected(true);
		radioJavaText.setBounds(80, 600, 109, 23);
		contentPane.add(radioJavaText);

		rdbtnBase = new JRadioButton("Base64");
		rdbtnBase.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (rdbtnBase.isSelected()) {
					if (codificacion == 0) {
						textDatos.setText(Utilidades.toBase(textDatos.getText()));
						codificacion = 2;
					} else if (codificacion == 1) {
						if (textDatos.getText().equals("")) {
							codificacion = 2;
						} else {
							if (textDatos.getText().matches("[0-9A-Fa-f]+")) {
								String aux = Utilidades.toStr(textDatos.getText());
								textDatos.setText(Utilidades.toBase(aux));
								codificacion = 2;

							} else {
								JOptionPane.showMessageDialog(null, "El mensaje contiene caracteres no Hexadecimales");
								rdbtnHexadecimal.setSelected(true);
							}
						}
					}
				}
			}
		});
		grupo_text_Hex.add(rdbtnBase);
		rdbtnBase.setBounds(333, 159, 109, 23);
		contentPane.add(rdbtnBase);

		rdbtnBase_1 = new JRadioButton("Base64");
		buttonGroup.add(rdbtnBase_1);
		rdbtnBase_1.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (rdbtnBase_1.isSelected()) {
					if (codificacionRespuesta == 0) {
						textRespuesta.setText(Utilidades.toBase(textRespuesta.getText()));
						codificacionRespuesta = 2;
					} else if (codificacionRespuesta == 1) {
						if (textRespuesta.getText().equals("")) {
							codificacionRespuesta = 2;
						} else {
						if (textRespuesta.getText().matches("[0-9A-Fa-f]+")) {
							String aux = Utilidades.toStr(textRespuesta.getText());
							textRespuesta.setText(Utilidades.toBase(aux));
							codificacionRespuesta = 2;

						} else {
							JOptionPane.showMessageDialog(null, "El mensaje contiene caracteres no Hexadecimales");
							rdbtnHexadecimal_1.setSelected(true);
						}
					}
					}
				}
			}
		});
		rdbtnBase_1.setBounds(333, 472, 109, 23);
		contentPane.add(rdbtnBase_1);

		radioJavaBase = new JRadioButton("Base64");
		radioJavaBase.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
				if (radioJavaBase.isSelected()) {
					if (codificacionJava == 0) {
						textJava.setText(Utilidades.toBase(textJava.getText()));
						codificacionJava = 2;
					} else if (codificacionJava == 1) {
						if (textJava.getText().equals("")) {
							codificacionJava = 2;
						} else {
							if (textJava.getText().matches("[0-9A-Fa-f]+")) {
								String aux = Utilidades.toStr(textJava.getText());
								textJava.setText(Utilidades.toBase(aux));
								codificacionJava = 2;

							} else {
								JOptionPane.showMessageDialog(null, "El mensaje contiene caracteres no Hexadecimales");
								radioJavaHex.setSelected(true);
							}
						}
					}
				}
			}
		});
		buttonGroup_1.add(radioJavaBase);
		radioJavaBase.setBounds(333, 600, 109, 23);
		contentPane.add(radioJavaBase);

	}

	private void actualizaPuertos() {
		Vector<String> portVect = network.getPortList();
		for (String value : portVect) {
			comboPuerto.addItem(value);
			System.out.println(value);
		}

	}

	public void writeClave(int i, String string) {
		textClave.setText(string);
	}

	public void writeArchivo(int id, String text) {
		// TODO Auto-generated method stub
		if (chckGuardar.isSelected()) {
			if (textSalida.getText().equals("")) {
				JOptionPane.showMessageDialog(null, "No has seleccionado la salida");
			} else {

				try {
					String encriptar = "";
					OutputStream fout = new FileOutputStream(textSalida.getText());
					OutputStreamWriter fichero = new OutputStreamWriter(fout, "ISO-8859-1");
					fichero.write("Algoritmo=" + comboAlgoritmo.getSelectedItem().toString() + "\r\n");
					fichero.write("Modo=" + comboModo.getSelectedItem().toString() + "\r\n");
					if (radioHexClave.isSelected()) {
						fichero.write("Clave=" + textClave.getText().toString() + "\r\n");
					} else {
						fichero.write("Clave=" + Utilidades.toHex(textClave.getText().toString()) + "\r\n");
					}

					if (rdbtnEncriptar.isSelected()) {
						encriptar = "desencriptar";
					} else {
						encriptar = "encriptar";
					}

					fichero.write("Encriptar=" + encriptar + "\r\n");
					fichero.write("Vector=" + textVector.getText() + "\r\n");
					fichero.write("Mensaje=" + text + "\r\n");
					fichero.close();
					fout.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

				// para ficheros con smbolos propios del espaol,
				// utilizar la codificacin "ISO-8859-1"

			}

		}
		// textRespuesta.append(text);

	}

	@Override
	public void setPublicKey(long publ_key) {
		// TODO Auto-generated method stub

		this.publ_key = publ_key;

	}

	@Override
	public void writeLog(int id, String text) {
		// TODO Auto-generated method stub

		textLog.append(text);

	}

	@Override
	public void writeRespuesta(int id, String text) {
		// TODO Auto-generated method stub
		rdbtnHexadecimal_1.setSelected(true);
		textRespuesta.setText(text);

	}

	@Override
	public void networkDisconnected(int id) {
		// TODO Auto-generated method stub
		System.exit(0);

	}

	@Override
	public void compruebaChecksum(String mensaje, String checksum) {

		if ((comboAlgoritmo.getSelectedIndex() != 4) || (rdbtnEncriptar.isSelected())) {
			mensaje = Utilidades.toStr(mensaje);
		}

		String chk_men = Utilidades.getMD5(mensaje);
		writeLog(0, "\nChecksum generado: " + chk_men + "\n");

		if (chk_men.contains(checksum)) {
			writeLog(0, "Mensaje Recibido correctamente \n");
		} else {
			writeLog(0, "Los checksum no son iguales \n" + checksum);
		}

	}

	@Override
	public void setModule(long module) {
		// TODO Auto-generated method stub
		this.publ_mod = module;
	}
}
